/*********************************************************************
 * This file is part of the PRAPI library.
 *
 * Copyright (C) 2001 Topi Menp and Jaakko Viertola
 * All rights reserved.
 *
 * This program is free software. You can redistribute and/or modify
 * it under the terms of the free software licence found in the
 * accompanying file "COPYING". The licence terms must always be
 * redistributed with this source file. The above copyright notice
 * must be reproduced in all modified and unmodified copies of this
 * source file.
 *
 * $Revision: 1.2 $
 *********************************************************************/

#ifndef _COMPNORM_H
#define _COMPNORM_H

#include "../ImageTransform.h"
#include "../Color.h"

namespace prapi { namespace color {

	/**
	 * "Comprehensive Normalization" for RGB color images as described
	 * by Finlayson et.al.
	 **/
	class CompNorm : public ImageTransform<RGBColor<>,RGBColor<> >
	{
	public:
		/**
		 * Normalize an RGB color image using the comprehensive
		 * normalization algorithm. A newly created normalized image is
		 * returned.
		 **/
		util::Matrix<RGBColor<> > getTransformedImage(const util::Matrix<RGBColor<> >& mat) throw (ImageTransformException&);
	};
}}

#endif
