/*********************************************************************
 * This file is part of the PRAPI library.
 *
 * Copyright (C) 2001 Jaakko Viertola
 * All rights reserved.
 *
 * This program is free software. You can redistribute and/or modify
 * it under the terms of the free software licence found in the
 * accompanying file "COPYING". The licence terms must always be
 * redistributed with this source file. The above copyright notice
 * must be reproduced in all modified and unmodified copies of this
 * source file.
 *
 * $Revision: 1.1 $
 *********************************************************************/

#ifndef _OUTEXRESULT_H
#define _OUTEXRESULT_H

#include <fstream>

namespace prapi { namespace extras {

	/**
	 * This class is the container for Outex results.
	 **/
	class OutexResult
	{
	public:
		/**
		 * The costructor of class.
		 **/
		OutexResult(double minValue,double maxValue,double meanValue, double stdevValue) :
			min(minValue),max(maxValue),mean(meanValue),stdev(stdevValue) {}
		/**
		 * The costructor of class.
		 **/
		OutexResult() : min(0.0),max(0.0),mean(0.0),stdev(0.0) {}

		/**
		 * The min value.
		 **/
		double min;
		/**
		 * The max value.
		 **/
		double max;
		/**
		 * The mean value.
		 **/
		double mean;
		/**
		 * The standart deviation.
		 **/
		double stdev;
	};
}}

#endif
