/*********************************************************************
 * This file is part of the cpplibs suite.
 *
 * Copyright (C) 2001 Topi Menp
 * All rights reserved.
 *
 * This program is free software. You can redistribute and/or modify
 * it under the terms of the free software licence found in the
 * accompanying file "COPYING". The licence terms must always be
 * redistributed with this source file. The above copyright notice
 * must be reproduced in all modified and unmodified copies of this
 * source file.
 *
 * $Revision: 1.3 $
 *********************************************************************/

#include "Object.h"
#include "Util.h"
#include "Exception.h"

namespace util
{
	std::string Object::getClassName() const { return Util::getClassName(*this); }

	Object* Object::clone() const //throw (NotCloneableException&)
	{
		throw NotCloneableException("Object::clone(): cannot clone a " + getClassName());
	}
}
