/*********************************************************************
 * This file is part of the cpplibs suite.
 *
 * Copyright (C) 2001 Topi Menp
 * All rights reserved.
 *
 * This program is free software. You can redistribute and/or modify
 * it under the terms of the free software licence found in the
 * accompanying file "COPYING". The licence terms must always be
 * redistributed with this source file. The above copyright notice
 * must be reproduced in all modified and unmodified copies of this
 * source file.
 *
 * $Revision: 1.3 $
 *********************************************************************/

#ifndef _PRIMITIVETYPE_H
#define _PRIMITIVETYPE_H

#include "Computable.h"

namespace util
{
	/**
	 * A base class for all primitive type wrappers (numbers,Boolean).
	 **/
	class PrimitiveType : virtual public Computable
	{
	public:
		/**
		 * All primitive types can be used as truth values. Typically,
		 * this function should return true if the current value of the
		 * type is different from zero.
		 **/
		virtual operator bool() const throw (ComputationException&) = 0;
	};
}

#endif
